//<Script type="text/javascript">

Gtk = imports.gi.Gtk;
Gio = imports.gi.Gio;
Gdk = imports.gi.Gdk;

imports['Object.js'].load(Object); 

File        = imports['File.js'].File; 
JSDOC       = imports['JSDOC.js'].JSDOC; 
console     = imports['console.js'].console; 
Introspect  = imports['JSDOC/Introspect.js'].Introspect; 

var outputdir = Seed.argv[2];

if (!outputdir) {
    throw {
        name: "ArgumentError", 
        message: "No output directory specified on the command line\n" +
          "Usage seed docs.js /var/www/seed  [Gtk] \n"
    };
}

if (!File.isDirectory(outputdir)) {
    console.log("Creating directory " + outputdir);
    File.mkdir(outputdir);
};

// list namespace..
//var ns_list = [ 'GIRepository' ];



var ns_list = JSDOC.Introspect.namespaces();
if (typeof(Seed.argv[3]) == 'string') {
    console.log(Seed.argv.length);
    ns_list = Seed.argv[3].split(',');
}
 
ns_list = ns_list .sort();
var cls_list = [];
var cls_template = new JSDOC.Template(__script_path__ + '/docs/class.html');
var cls_ix_template = new JSDOC.Template(__script_path__ + '/docs/class_ix.html');
var reference_template = new JSDOC.Template(__script_path__ + '/docs/references.html');
 
ns_list.map(function(ns_name) 
{
    var  core = imports.gi[ns_name];
   
    console.log("START:" + ns_name);
   
    var ns = Introspect.ns(ns_name);
    ns['left_bar'] = cls_ix_template.process(ns);

    Gio.simple_write(outputdir + '/'+ ns_name +  '.html', cls_template.process(ns));
    
    cls_list.push({
        alias : ns_name 
    });
    
    // left bar index of elements in namespace...
    Gio.simple_write(outputdir + '/_ix_'+ ns_name +  '.shtml', cls_ix_template.process(ns));
     
    
    var actions = {
        'objects' : 'Class',
        'interfaces' : 'Interface',
        'structs' : 'Struct',
        'unions' : 'Union',
        'enums' : 'Enum'
        
    };
    for (var i in actions) {
        ns.objects.map( function(n) {
            Gio.simple_write(outputdir + '/'+ ns_name + '.' + n + '.html', 
                cls_template.process(
                    Object.extend(
                        Introspect.factory(actions[i], ns_name, n),
                        { 'left_bar' :ns['left_bar'] }
                    )
                )
            )
                       
            console.log(ns_name + '.' +n);
        }); 
    }
    
      
});

var refs = '';
var html_file_path = '';
var html = ''


for (var i in Introspect.references) {
    html_file_path = File.join(outputdir, i + '.html');
  
    if (i == 'undefined') {
      console.log("Undefined name space - ignored");
      continue;
    }
    if (!File.isFile(html_file_path)) {
      console.log("No HTML file " + html_file_path + " to insert references into - ignored");
      continue;
    }
    
    refs = reference_template.process(Introspect.references[i]);

      // HTML to put refs into
    html =  File.read(html_file_path);

      // do the replacement
    html = html.replace(/\<!--references--\>/, refs);

      // write back to file
    Gio.simple_write(html_file_path, html);

}

var ix_template = new JSDOC.Template(__script_path__ + '/docs/index.html');
Gio.simple_write(outputdir + '/index.html', ix_template.process(ns_list));
File.silentRecursiveCopy(__script_path__ + '/docs/resources/', outputdir);



